#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define sz(a) (int)a.size()
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second

using namespace std;

const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;
const ll big = (ll)1e18 + 1;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

template<class T>
void print(vector<pair<T, T> > s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i].first << " " << s[i].second << endl;
    cout << endl;
}

template<class T>
void print(vector<vector<T> > s){
    for (int i = 0; i < s.size(); i++)
        print(s[i]);
    cout << endl;
}


int main()
{
    //freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int a[n];
    rep(i, 0, n)
        cin >> a[i];
    string s;
    cin >> s;
    int l[n], r[n];
    vector<pair<int, int> > st;
    st.push_back({inf, -1});
    rep(i, 0, n)
    {
        l[i] = sz(st) - 1;
        while (st.back().fi < a[i])
            st.pop_back();
        st.push_back({a[i], i});
    }
    st.clear();
    st.push_back({inf, n});
    repb(i, n - 1, -1)
    {
        r[i] = sz(st) - 1;
        while (st.back().fi < a[i])
            st.pop_back();
        st.push_back({a[i], i});
    }
    rep(i, 0, n)
        if (s[i] == 'L')
            cout << l[i] << " ";
        else
            cout << r[i] << " ";
    cout << "\n";
    return 0;
}
