/*******************************************************
 * Copyright (C) 2017
 *  Computer Graphics Support Group of 30 Phys-Math Lyceum
 *******************************************************/
/* FILE NAME  : MAIN.CPP
 * PURPOSE    : The main program file
 * PROGRAMMER : LZ5
 *             AK5
 *             VG5
 * LAST UPDATE: 05.11.2017
 * NOTE: None.
 *
 * No part of this file may be changed without agreement of
 * Computer Graphics Support Group of 30 Phys-Math Lyceum
 */
#include <cstdio>
#include <cmath>

/* The main program function.
 * ARGUMENTS: None.
 * RETURNS:
 *   (int) 0 if success.
 */
int main( void )
{
  int n, k, num_del = 2, flag = 1;

  scanf_s("%i %i", &n, &k);

  printf("*");
  if (k == 1)
    printf(".");
  else
  printf("*");


  for (int i = 3; i <= n * n; i++)
  {
    for (int j = ceil((float)i / 2); j > 1; j--)
    {
      if (i % j == 0)
        num_del++;
      if (num_del > k)
      {
        printf(".");
        num_del = 2;
        flag = 0;
        break;
      }
    }
    if (flag)
      printf("*");
    flag = 1;
    if (i % n == 0)
      printf("\n");
    num_del = 2;
  }

  return 0;
} /* End of 'main' function */

/* END OF 'MAIN' FUNCTION */