/*************************************************************
 * Copyright (c) 2017
 *   Galinsky software
 *   Computer Graphics Support Group of 30 Phys-Math Lyceum
 ************************************************************/

/* FILE NAME:  K.CPP
 * PURPOSE:    None.
 * PROGRAMMER: CGSG'2017
 *             Dmitriev-Lappo Yaroslav
 *             Smirnov Arsenty
 *             Malets Lev
 * NOTE:       None.
 *
 * No part of this file may be changed without agreement of
 * Galinsky Vitaly personally and
 * Computer Graphics Support Group of 30 Phys-Math Lyceum
 */

/******************************
/*        13h games           *
/******************************

/* Defines: */

/* *****
 *  *
 *******
    ****
 ****  */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <Windows.h>
#include <string>
#include <algorithm>
#include <array>
#include <cmath>
#include <vector>

#define TRU 1
#define FOLS 0
using BULL = BOOL;

VOID main( VOID )
{
  UINT n;
  std::vector<UINT> Un;

  scanf("%i", &n);

  Un.resize(n);
  for (UINT i = 0; i < n; i++)
  {
    UINT Alien;
    scanf("%i", &Alien);
    Un[i] = INT(i) + INT(1) - INT(Alien) >= 0 ? i + 1 - Alien : n - Alien + i + 1;
  }

  std::sort(Un.begin(), Un.end());

  if (Un[0] != 0)
  {
    printf("%i", 0);
    exit(0);
  }

  for (UINT i = 1; i < n; i++)
  {
    if (Un[i] > Un[i - 1] + 1)
    {
      printf("%i", Un[i - 1] + 1);
      exit(0);
    }
  }

  printf("%i", Un[Un.size() - 1] + 1 == n ? -1 : Un[Un.size() - 1] + 1);
  exit(0);
}
