#define _CRT_SECURE_NO_WARNINGS 
#include <vector>
#include <string>
#include <iostream>
#include <cmath>

std::vector<std::string> Parse( const std::string &Str )
{
  std::string cur;
  std::vector<std::string> res;

  for (int i = 0, size = Str.size(); i < size; i++)
  {
    if (Str[i] == ' ')
      res.push_back(cur), cur.clear();
    else
      cur.push_back(Str[i]);
  }
  return res;
}

void main( void )
{
  std::vector<std::string> twint;

  int n;
  std::cin >> n;

  getchar();

  char buf[200];

  for (int i = 0; i < n; i++)
  {
    std::cin.getline(buf, 200);

    auto tmp(Parse(buf));

    for (int i = 0, size = tmp.size(); i < size; i++)
      twint.push_back(tmp[i]);
  }

  int zn, numr = 0;
  for (zn = 1; zn <= 4; zn++)
  {
    // number of digits in number of rows

    std::string s(zn, ' ');

    int i = 0, size = twint.size(), row = 1;

    while (i < size)
    {
      sprintf(buf, "(%i/%s)", row, s.c_str());

      int len = 280 - strlen(buf);
      while (i < size)
      {
        len -= twint[i].size() + 1;

        if (len < 0)
        {
          break;
        }
        i++;
      }
      row++;

      if (row >= pow(10, zn + 1))
        break;
    }

    numr = row - 1;

    if (i == size)
      break;
  }

  int i = 0, size = twint.size(), row = 1;

  std::cout << numr << std::endl;
  
  while (i < size)
  {
    sprintf(buf, "(%i/%i)", row, numr);
  
    std::string res;
    int len = 280 - strlen(buf);
    while (i < size)
    {
      len -= twint[i].size() + 1;
  
      if (len < 0)
      {
        break;
      }
      res.append(twint[i].c_str());
      res.append(" ");
      i++;
    }
    res.append(buf);

    std::cout << res << std::endl;

    row++;
  
    if (row >= pow(10, zn + 1))
      break;
  }
}