#include <bits/stdc++.h>

using namespace std;

struct B_I_T
{
    vector<int> arr;
    B_I_T(int n = 0) : arr(n, 0) {}
    void add(int x, int val)
    {
        if (x < 0)
            return;
        for (int i = x; i < arr.size(); i = (i | (i + 1)))
            arr[i] += val;
    }
    int get(int x)
    {
        int ret = 0;
        for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
            ret += arr[i];
        return ret;
    }
};

vector<int> sol(vector<int> h)
{
    int n = h.size();
    vector<int> ph(1, -1);
    B_I_T arr(n);
    for (int i = 1; i < n; i++)
    {
        int j = i - 1;
        while(j >= 0 && h[j] <= h[i])
            j = ph[j];
        ph.push_back(j);
        //cerr << "add " << ph.back() + 1 << " " << i << "\n";
        arr.add(max(ph.back(), 0), 1);
        arr.add(i, -1);
    }
    vector<int> ret;
    for (int i = 0; i < n; i++)
        ret.push_back(arr.get(i));
    return ret;
}

int main() {
    int n; cin >> n;
    vector<int> arr(n);
    for (int &i : arr)
        cin >> i;
    string s;
    cin >> s;
    auto ansr = sol(arr);
    reverse(arr.begin(), arr.end());
    auto ansl = sol(arr);
    reverse(ansl.begin(), ansl.end());
    for (int i = 0; i < n; i++)
    {
        if (s[i] == 'R')
            cout << ansr[i] << " ";
        else
            cout << ansl[i] << " ";
    }
    return 0;
}
