#include <iostream>
#include <string>
#include <vector>

using namespace std;

int main()
{
	int n;
	cin >> n;

	vector<unsigned long> height(n);
	for (int i = 0; i < n; i++)
		cin >> height[i];

	string directions;
	cin >> directions;

	vector<unsigned long> visibility(n);

	char last = ' ';

	for (int i = 0; i < n; i++)
	{
		if (directions[i] == 'L')
		{
			unsigned long max = 0;
			if (i == 0)
				visibility[i] = 0;
			else if (last == 'L' && height[i - 1] <= height[i])
				visibility[i] = visibility[i - 1] + 1;
			else
			{
				for (int j = i - 1; j >= 0; j--)
					if (height[j] >= max)
					{
						visibility[i]++;
						max = height[j];
					}
			}
			last = 'L';
		}

		else
		{
			unsigned long max = 0;
			if (i == n - 1)
				visibility[i] = 0;
			else
			{
				for (int j = i+1; j < n; j++)
					if (height[j] >= max)
					{
						visibility[i]++;
						max = height[j];
					}
			}
		}

	}
	for (int i = 0; i < n; i++)
		cout << visibility[i] << ' ';

	system("pause");
	return 0;
}