from sys import stdin, stdout

def dfs(vortex, graph, used, prev, start, startcol, ans, cool):
    if vortex == start and prev != -1:
        cool[0] = True
        return
    for param in graph[vortex]:
        neigh = param[0]
        numb = param[1]
        w = param[2]
        if vortex == start:
            startcol[0] = w
        if not used[numb] and w != prev:
            if neigh == start and w == startcol[0]:
                continue
            used[numb] = True
            dfs(neigh, graph, used, w, start, startcol, ans, cool)
            used[numb] = False
            if cool[0]:
                ans.append(numb + 1)
                return

def main():
    t = int(stdin.readline())
    for _ in range(t):
        n, m = map(int, stdin.readline().split())
        graph = [[] for _ in range(n)]
        used = [False] * m
        for i in range(m):
            a, b, c = map(int, stdin.readline().split())
            graph[a-1].append((b-1, i, c))
        used = [False] * m
        ans = []
        cool = []
        cool.append(False)
        startcol = []
        startcol.append(-1)
        for i in range(n):
            dfs(i, graph, used, -1, i, startcol, ans, cool)
            if cool[0]:
                break
        if len(ans) == 0:
            print("-1")
        else:
            ans.reverse()
            print(len(ans))
            print(*ans)

if __name__ == '__main__':
    main()