#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;
/*3
An example with sylla- (1/3)
bification and punctuation (2/3)
! (3/3)*/
string get_end(int num, int n)
{
	string str_num, str_n;

	for (num; num > 0; num /= 10)
		str_num.push_back('0' + num % 10);
	reverse(str_num.begin(), str_num.end());
	for (n; n > 0; n /= 10)
		str_n.push_back('0' + n % 10);
	reverse(str_n.begin(), str_n.end());
	return "(" + str_num + "/" + str_n + ")";
}

vector<string> get_vect(string str)
{
	string add;
	vector<string> vect;

	for (int i = 0; i < str.size(); i++)
	{
		if (str[i] == ' ')
		{
			vect.push_back(add);
			add.clear();
		}
		else
			add.push_back(str[i]);
	}
	vect.push_back(add);
	return vect;
}

int main()
{
	//ios::sync_with_stdio(false);
	const int SIZE = 5000;
	static vector<string> text, blocks[SIZE], out_str;
	string str, end_str;
	int n, num, size, l, r, m;
	char ch;

	cin >> n;
	//cout << "YES\n";
	cin >> ch;
	for (int i = 0; i < n; i++)
	{	
		getline(cin, str);
		if (i == 0)
		{
			str = ch + str;
		}
		//if (i != n - 1)
			//cin >> ch;
		//cout << "\ns = " << str << endl;
		text = get_vect(str);
		num = 0;
		for (int i = 1; text[text.size() - 1][i] != '/'; i++)
			num = num * 10 + (text[text.size() - 1][i] - '0');
		if (!text.empty())
			text.pop_back();
		blocks[num - 1] = text;
	}
	text.clear();
	for (int i = 0; i < n; i++)
		for (int j = 0; j < blocks[i].size(); j++)
			text.push_back(blocks[i][j]);
	l = 0;
	r = n;
	while (r - l > 1)
	{
		m = (l + r) / 2;
		num = 1;
		size = 0;
		end_str = get_end(1, m);
		for (int i = 0; i < text.size(); i++)
		{
			if (size + end_str.size() > 280)
			{
				num++;
				end_str = get_end(num, m);
				size = 0;
			}
			size += text[i].size() + 1;
		}
		if (num <= m)
			r = m;
		else
			l = m;
		out_str.clear();
	}
	num = 1;
	size = 0; 
	end_str = get_end(1, r);
	cout << r << endl;
	for (int i = 0; i < text.size(); i++)
	{
		if (size + end_str.size() > 280)
		{
			out_str.push_back(end_str);
			out_str.push_back("\n");
			num++;
			end_str = get_end(num, r);
			size = 0;
		}
		out_str.push_back(text[i]);
		out_str.push_back(" ");
		size += text[i].size() + 1;
	}
	if (out_str[out_str.size() - 1][0] != '(')
		out_str.push_back(end_str);
	for (int i = 0; i < out_str.size(); i++)
		cout << out_str[i];
}
