#include <stdio.h>
#include <time.h>

void Swap(int *a, int *b)
{
	int tmp = *a;
	*a = *b;
	*b = tmp;
}

void Sort( int mas[] )
{
	int last = 2;

	do
	{
		int changed = 0;
		for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3 - i; j++)
				if (mas[j] > mas[j + 1])
					Swap(&mas[j], &mas[j + 1]), changed = i;
		last = changed - 1;
	} while (last >= 0);
}

int main( void )
{
	long t;
	int a, b, c, d;

	t = clock();
	scanf("%i%i%i%i", &a, &b, &c, &d);
	if (a == b && b == c && c == d)
		printf("%i %i %i %i", a, b, c, d);
	else if (a > b && b > c && c > d )
		printf("%i %i %i %i", d, b, c, a);
	else if (a < b && b < c && c < d)
		printf("%i %i %i %i", a, c, b, d);
	else
	{
		int mas[4] = { a, b, c, d };
		Sort(mas);
		printf("%i %i %i %i\n", mas[0], mas[2], mas[1], mas[3]);
	}
	return 0;
}