#define X
#ifdef X

#include <iostream>
#include <algorithm>
#include <iterator>
#include <vector>
#include <map>
#include <set>
#include <climits>
#include <cmath>
#include <string>
using namespace std;

typedef long double lf;
typedef long long int lli;
#define SIZE(x) ((lli)(x.size()))
#define forn(i, n) for (lli i = 0; i < n; ++i)

lf a, b, c, d;

lf value(string s)
{
	vector<lf> n;
	for (auto x : s)
		switch (x) {
		case 'a':
			n.push_back(a);
			break;
		case 'b':
			n.push_back(b);
			break;
		case 'c':
			n.push_back(c);
			break;
		case 'd':
			n.push_back(d);
			break;
		}
	return  n[0] / n[1] + n[2] / n[3];
}

int main()
{
	cin >> a >> b >> c >> d;
	string s = "abcd";
	map<string, lf> m;
	do {
		m[s] = value(s);
	} while (next_permutation(s.begin(), s.end()));

	pair<string, lf> t = make_pair("", 100);
	for (auto x : m)
		if (x.second < t.second)
			t = x;
	
	vector<lf> n;
	for (auto x : t.first)
		switch (x) {
		case 'a':
			cout << a << " ";
			break;
		case 'b':
			cout << b << " ";
			break;
		case 'c':
			cout << c << " ";
			break;
		case 'd':
			cout << d << " ";
			break;
		}

	//system("pause");
	return 0;
}

#endif