#include <iostream>
#include <bits/stdc++.h>
using namespace std;

const int INF = 1e7;

vector<int> solve(vector<long long>& h)
{
    int n = h.size();
    multiset<long long> s;
    vector<int> ans(n);
    s.insert(h[0]);
    for(int i = 1; i < n; i++)
    {
        while(*s.begin() < h[i - 1])
            s.erase(s.begin());
        ans[i] = s.size();
        s.insert(h[i]);
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<long long> a(n), b;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    b = a;
    reverse(b.begin(), b.end());
    vector<int> x = solve(a), y = solve(b);
    reverse(y.begin(), y.end());
    for(int i = 0; i < n; i++)
    {
        char c; cin >> c;
        if(c == 'L')
            cout << x[i];
        else
            cout << y[i];
        cout << " ";
    }
    return 0;
}
