import java.io.*;
import java.util.*;


public class J {
	
	String generateEnding(int a, int b) {
		return " (" + a + "/" + b + ")";
	}
	
	int getLen(int x) {
		return (x + "").length();
	}
	
	public void solve() throws IOException {
		int k = Integer.parseInt(br.readLine());
		String[][] wordsBefore = new String[k][];
		for (int i = 0; i < k; ++i) {
			wordsBefore[i] = br.readLine().split(" ");
		}
		
		ArrayList<String> pureWords = new ArrayList<>();
		for (int i = 0; i < k; ++i) {
			for (int j = 0; j < wordsBefore[i].length - 1; ++j) {
				pureWords.add(wordsBefore[i][j]);
			}
		}
		
		
		outer: 
		for (int resLen = 1;; resLen++) {
			int curWord = 0;
			
			ArrayList<StringBuilder> result = new ArrayList<>();
			for (int i = 1;;i++) {
				if (getLen(i) > resLen) {
					continue outer;
				}
				if (curWord >= pureWords.size()) {
					break;
				}
				StringBuilder currentLine = new StringBuilder();
				int charsLeft = 280 - getLen(i) - resLen - 4;
				
				if (curWord >= pureWords.size()) {
					result.add(currentLine);
					break;
				}
				String firstWord = pureWords.get(curWord++);
				
				
				charsLeft -= firstWord.length();
				currentLine.append(firstWord);
				
				if (curWord >= pureWords.size()) {
					result.add(currentLine);
					break;
				}
							
				
				String currentWord = pureWords.get(curWord);
//				System.out.println(currentWord);
				
				boolean addLine = true;
				while (charsLeft >= currentWord.length() + 1) {
					charsLeft -= (currentWord.length() + 1);
					currentLine.append(" " + currentWord);
					
					curWord++;
					if (curWord >= pureWords.size()) {
//						System.out.println("C " + currentLine);
						break;
					}
					currentWord = pureWords.get(curWord);
					//System.out.println(currentWord);
				}
				
				result.add(currentLine);
				
			}
			
			
			
			
			// alright
			out.println(result.size());
			for (int i = 0; i < result.size(); ++i) {
				result.get(i).append(generateEnding(i + 1, result.size()));
				out.println(result.get(i).toString());
			}
			
			return;
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new J().run();
	}

}
