#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

void print (vector<auto> &tp)
{
    for (auto i : tp)
        cout << i << " ";
    cout << endl;
}

vector<ll> DO(4 * 100000 + 1);
vector<ll> mas;
vector<ll> DO_R(4 * 100000 + 1);
vector<ll> DO_L(4 * 100000 + 1);
int n;

void build_tree(int a, int l, int r)
{
    //cout << "build: " << l << " " << r << endl;
    if (r - l == 1)
    {
        DO[a] = mas[l];
        DO_L[a] = 0LL;
        DO_R[a] = 0LL;
        return;
    }
    int mid = (l + r) / 2;
    build_tree(a * 2 + 1, l, mid);
    build_tree(a * 2 + 2, mid, r);
    DO[a] = max(DO[a * 2 + 1], DO[a * 2 + 2]);
}

ll get_max(int a, int l, int r, int ql, int qr)
{
    if (l >= qr || r <= ql)
        return -1e18;
    if (ql <= l && r <= qr)
        return DO[a];
    int mid = (l + r) / 2;
    return max(get_max(a * 2 + 1, l, mid, ql, qr),
               get_max(a * 2 + 2, mid, r, ql, qr));
}

void incrase(int a, int l, int r, int ql, int qr, ll data, char LR)
{
    //cout << "l, r : " << l << " " << r << " " << LR << endl;
    if (l >= qr || r <= ql)
        return;
    if (ql <= l && r <= qr)
    {
        if (LR == 'R')
            DO_R[a] += data;
        else
            DO_L[a] += data;
        return;
    }
    int mid = (l + r) / 2;
    incrase(a * 2 + 1, l, mid, ql, qr, data, LR);
    incrase(a * 2 + 2, mid, r, ql, qr, data, LR);
}

ll get_ans(int a, int l, int r, int q, char LR)
{
    ll ans;
    if (q < l || q >= r)
        return 0LL;

    if (LR == 'R')
        ans = DO_R[a];
    else
        ans = DO_L[a];

    if (r - l == 1)
        return ans;

    ll mid = (l + r) / 2;
    ans += get_ans(a * 2 + 1, l, mid, q, LR) + get_ans(a * 2 + 2, mid, r, q, LR);
    return ans;
}



ll get_l(int pos)
{
    int r = pos, l = -1, mid;
    while(r - l > 1)
    {
        mid = (l + r) / 2;
        //cout << "mid : " << mid << " get_max[" << mid << "," << pos << "):"  << get_max(0, 0, n, mid, pos) << endl;
        if (get_max(0, 0, n, mid, pos) > mas[pos])
            l = mid;
        else
            r = mid;
    }
    return r - 1;
}

ll get_r(int pos)
{
    int l = pos + 1, r = n + 1, mid;
    while(r - l > 1)
    {
        mid = (l + r) / 2;
        //cout << "mid : " << mid << " get_max[" << pos << "," << mid << "):"  << get_max(0, 0, n, pos, mid) << endl;
        if (get_max(0, 0, n, pos, mid) > mas[pos])
            r = mid;
        else
            l = mid;
    }
    return l;
}

int main()
{
    //freopen("file.in", "r", stdin);
    cin >> n;
    mas.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> mas[i];
    build_tree(0, 0, n);
    //print(mas);
    string s;
    cin >> s;

    for (int i = 0; i < n; ++i)
    {
        int getl = get_l(i);
        int getr = get_r(i);
        if (getl == -1)
            getl = 0;
        if (getr == n)
            getr = n - 1;
        incrase(0, 0, n, getl, i, 1LL, 'R');
        incrase(0, 0, n, i + 1, getr + 1, 1LL, 'L');
    }
    for (int i = 0; i < n; ++i)
        cout << get_ans(0, 0, n, i, s[i]) << " ";
    return 0;
}

