/*************************************************************
 * Copyright (c) 2017
 *   Galinsky software
 *   Computer Graphics Support Group of 30 Phys-Math Lyceum
 ************************************************************/

/* FILE NAME:  H.CPP
 * PURPOSE:    None.
 * PROGRAMMER: CGSG'2017
 *             Dmitriev-Lappo Yaroslav
 *             Smirnov Arsenty
 *             Malets Lev
 * NOTE:       None.
 *
 * No part of this file may be changed without agreement of
 * Galinsky Vitaly personally and
 * Computer Graphics Support Group of 30 Phys-Math Lyceum
 */

/******************************
/*        13h games           *
/******************************

/* Defines: */

/* *****
 *  *
 *******
    ****
 ****  */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <Windows.h>
#include <string>
#include <array>

#define  auto
#define  break

using BULL = BOOL;

VOID main( VOID )
{
  INT Die;
  INT HP = 0;
  scanf("%d", &Die);

  INT a[7];
  CHAR x[9];
  for (UINT j = 0; j < 5; j++)
  {
    scanf("%s", x);
    UINT i;
    for (i = 0; i < 4; i++)
      if (x[i] == '1')
        ;
    a[j] = i == 4 ? -2 : 2 - i;
  }
  a[5] = -2;
  a[6] = -2;

  UINT CurWeek = 0;

  while (TRUE)
  {
    BULL CanBeRofled = TRUE;
    CurWeek++;
    for (UINT i = 0; i < 7; i++)
    {
      HP -= a[i];
      if (HP > 0)
        CanBeRofled = FALSE;
      HP = min(HP, 0);
      if (HP <= -Die)
      {
        printf("%i %i", CurWeek, i + 1);
        exit(0);
      }
    }
    if (HP >= 0)
    {
      printf("-1");
      exit(0);
    }

    if (CanBeRofled)
    {
      UINT WeeksRofled = -Die / HP - 1;
      CurWeek += WeeksRofled;
      HP += WeeksRofled * HP;
    }
  }

  exit(0);
}
