#include <bits/stdc++.h>

using namespace std;

vector<tuple<int, int, int> > e;
int n, m;
vector<tuple<int, int, int> > ver;
vector<vector<int> > g, in, out;
vector<int> color;
vector<int> st;
vector<int> cyc;

void upd(int x)
{
    if (!cyc.empty())
        return;
    for (int i = 0; i < st.size(); i++)
        if (st[i] == x)
        {
            for (int j = i; j < st.size(); j++)
                if (st[j] < m)
                    cyc.push_back(st[j]);
        }
}

void dfs(int p)
{
    color[p] = 1;
    st.push_back(p);
    for (int i : g[p])
    {
        if (color[i] == 1)
        {
            upd(i);
            continue;
        }
        if (color[i] == 2)
            continue;
        dfs(i);
    }
    color[p] = 2;
    st.pop_back();
}

void solve()
{
    e.clear();
    ver.clear();
    g.clear();
    in.clear();
    out.clear();
    scanf("%d%d", &n, &m);
    in.resize(n);
    out.resize(n);
    for (int i = 0; i < m; i++)
    {
        int s, f, c;
        scanf("%d%d%d", &s, &f, &c);
        s--, f--, c--;
        e.push_back(make_tuple(s, f, c));
        ver.push_back(make_tuple(s, c, 0));
        ver.push_back(make_tuple(f, c, 1));
        in[f].push_back(c);
        out[s].push_back(c);
    }
    for (int i = 0; i < n; i++)
    {
        sort(in[i].begin(), in[i].end());
        in[i].resize(unique(in[i].begin(), in[i].end()) - in[i].begin());
        sort(out[i].begin(), out[i].end());
        out[i].resize(unique(out[i].begin(), out[i].end()) - out[i].begin());
    }
    sort(ver.begin(), ver.end());
    ver.resize(unique(ver.begin(), ver.end()) - ver.begin());
    map<tuple<int, int, int>, int> mp;
    for (int i = 0; i < ver.size(); i++)
        mp[ver[i]] = i + m;
    g.resize(m + ver.size());
    for (int i = 0; i < m; i++)
    {
        int s = get<0>(e[i]);
        int f = get<1>(e[i]);
        int c = get<2>(e[i]);
        g[i].push_back(mp[make_tuple(f, c, 1)]);
        g[mp[make_tuple(s, c, 0)]].push_back(i);
    }
    for (int i = 0; i < n; i++)
    {
        vector<int> al;
        for (int x : in[i])
            al.push_back(x);
        for (int y : out[i])
            al.push_back(y);
        sort(al.begin(), al.end());
        al.resize(unique(al.begin(), al.end()) - al.begin());
        int st = g.size();
        int d = al.size();
        g.resize(st + 2 * al.size(), {});
        for (int x = 0; x < (int)al.size() - 1; x++)
            g[x + st].push_back(st + x + 1);
        for (int x = 1; x < (int)al.size(); x++)
            g[x + st + d].push_back(st + d + x - 1);
        for (int c : in[i])
        {
            int u = mp[make_tuple(i, c, 1)];
            int t = upper_bound(al.begin(), al.end(), c) - al.begin();
            if (t != al.size())
                g[u].push_back(st + t);
            t = lower_bound(al.begin(), al.end(), c) - al.begin();
            if (t != 0)
                g[u].push_back(st + d + t - 1);
        }
        for (int c : out[i])
        {
            int u = mp[make_tuple(i, c, 0)];
            int t = lower_bound(al.begin(), al.end(), c) - al.begin();
            g[st + t].push_back(u);
            g[st + d + t].push_back(u);
        }
    }
    int r = g.size();
    /*cout << r << "\n";
    for (int i = 0; i < r; i++)
    {
        cout << i << " --> ";
        for (int x : g[i])
            cout << x << " ";
        cout << "\n";
    }*/
    color.clear();
    color.assign(r, 0);
    st.clear();
    cyc.clear();
    for (int i = 0; i < r; i++)
        if (color[i] == 0)
            dfs(i);
    if (cyc.empty())
    {
        cout << "-1\n";
        return;
    }
    cout << cyc.size() << "\n";
    for (int i : cyc)
        cout << i + 1 << " ";
    cout << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int T;
    scanf("%d", &T);
    for (int i = 0; i < T; i++)
        solve();
    return 0;
}
