import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class G {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());

		int n = Integer.parseInt(st.nextToken());
		st = new StringTokenizer(br.readLine());
		int[] mars = new int[n];
		for (int i = 0; i < n; i++) {
			mars[i] = Integer.parseInt(st.nextToken());
		}
		int[] people = new int[n];
		for (int i = 0; i < n; i++) {
			people[i] = i + 1;
		}

		boolean[] dists = new boolean[n];
		int index = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++)
				if (mars[i] == people[j]) {
					index = j;
					break;
				}
			if (i - index >= 0)
				dists[i - index] = true;
			else
				dists[n + i - index] = true;
		}
		int min = n + 1;
		for (int i = 0; i < n; i++) {
			if (dists[i] == false && i < min)
				min = i;
		}
		if (min == n + 1)
			System.out.println(-1);
		else
			System.out.println(min);
	}
}
