import java.io.*;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;

public class A {
    String fileName = "A";

    Map<Integer, Integer> divCount = new HashMap<>(1000, 1f);

    public int divCount(int n) {
        divCount.clear();
        if (n == 2)
            return 2;
        int cur = 2;
        int x = n;
        while (x > 2) {
            while (x % cur == 0) {
                x /= cur;
                divCount.put(cur, divCount.getOrDefault(cur, 0) + 1);
            }
            cur++;
        }
        int ans = 1;
        for (int count : divCount.values()) {
            ans *= (count + 1);
        }
        return ans;
    }

    public void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        int cur = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (divCount(cur) <= k) {
                    out.print("*");
                } else {
                    out.print(".");
                }
                cur++;
            }
            out.print("\n");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }

}
