import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class G {
    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer stringTokenizer;
    int[] mass;

    String nextToken() throws IOException
    {
        if(stringTokenizer==null||!stringTokenizer.hasMoreTokens())
        {
            stringTokenizer=new StringTokenizer(bufferedReader.readLine());
        }
        return stringTokenizer.nextToken();
    }

    Integer nextInt() throws IOException{
        return Integer.parseInt(nextToken());
    }

    public int solution() throws  IOException
    {
        int n = nextInt();
        mass = new int[n];
        int ans=0;


        for (int i = 0; i < n; i++) {
            mass[i] = nextInt();
        }

        for (int j = 0; j < n; j++) {
            for (int i = 0; i < n; i++) {
                    if (mass[i] == i+1) {
                        ans++;
                        rotate();
                        break;
                    }
                }
        }

        if(ans>=n)
        {
            return -1;
        }
        else
        {
            return ans;
        }

    }

    public void rotate()
    {
        int temp;
        temp = mass[0];
        for (int i = 0; i < mass.length-1; i++) {
            mass[i] = mass[i+1];
        }
        mass[mass.length-1] = temp;

    }

    public static void main(String[] args) throws IOException{
        System.out.println(new G().solution());
    }

}
