import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.StringTokenizer;

public class Combinations {
    public static void main(String[] args) throws IOException {
        BufferedInputStream stream = new BufferedInputStream(System.in);

        StringBuilder builder = new StringBuilder();
        do {
            builder.appendCodePoint(stream.read());
        } while (stream.available() > 0);

        StringTokenizer tokenizer = new StringTokenizer(builder.toString());
        int n = Integer.parseInt(tokenizer.nextToken());

        builder = new StringBuilder();

        do {
            builder.append((char) stream.read());
        } while (stream.available() > 0);

        tokenizer = new StringTokenizer(builder.toString());

        int[] i = new int[n];

        for (int a = 0; a < n; a++)
            i[a] = Integer.parseInt(tokenizer.nextToken());

        for (int a = 0; a < n; a++) {
            if (willWin(i, a)) {
                System.out.println(a);
                return;
            }
        }
        System.out.println(-1);
    }

    private static boolean willWin(int i1[], int bias) {
        for (int a = 0; a < i1.length; a++)
            if (i1[a] == (a+1 - bias < 1 ? a+1 - bias + i1.length : a+1 - bias))
                return false;
        return true;
    }
}
