#include <stdio.h>
#include <stdlib.h>

int Fight(int *E, int *M, int n)
{
	int i;

	for (i = 0; i < n; i++)
		if (E[i] == M[i])
			return 0;

	return 1;
}

void Swap(int *E, int n)
{
	int i, tmp;
	tmp = E[n - 1];

	for (i = n - 1; i > 0; i--)
		E[i] = E[i - 1];

	E[0] = tmp;
}

int main(void)
{
	int n, *M, *E, i, time = 0;

	scanf_s("%i", &n);

	M = (int*)malloc(sizeof(int) * n * n);
	E = (int*)malloc(sizeof(int) * n * n);

	for (i = 0; i < n; i++)
		scanf("%i", &M[i]);
	for (i = 0; i < n; i++)
		E[i] = i + 1;

	while (!Fight(E, M, n))
	{ 
		if (time > n)
		{
			printf("-1");
			break;
		}
		Swap(E, n);
		time++;
	}

	if (!(time > n))
	  printf("%i", time);

	return 0;
}