import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class ProblemA {
	String fileName = "<name>";

	public void solve() throws IOException {
		// write your code here
		int n = nextInt();
		int k = nextInt();
		if (k == 1 || k == 2) {
			for (int i = 0; i < n; i++) {
				for (int j = 1; j <= n; j++) {
					System.out.print(".");
				}
				System.out.println();
			}
		} else {

			for (int i = 0; i < n; i++) {
				for (int j = 1; j <= n; j++) {
					int num = i * n + j;
					int del = 2;
					for (int q = 2; q < num / 2 + 1; q++) {
						if (num % q == 0)
							del++;
					}
					if (del >= k)
						System.out.print(".");
					else
						System.out.print("*");
				}
				System.out.println();
			}
		}
	}

	public void run() {
		try {
			InputStreamReader isr = new InputStreamReader(System.in);

			br = new BufferedReader(isr);
			out = new PrintWriter(System.out, true);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new ProblemA().run();
	}

}
