import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.Collections;
import java.util.Locale;
import java.util.StringTokenizer;

public class ProblemD {
	String fileName = "<name>";

	public void solve() throws IOException {
		// write your code here
		int n = nextInt();
		int h[] = new int[n];
		for (int i = 0; i < n; i++)
			h[i] = nextInt();
		String s = nextToken();
		char c[] = s.toCharArray();
		for (int i = 0; i < n; i++) {
			int ans = 0;
			int max = 0;
			if (c[i] == 'L') {

				for (int j = i - 1; j >= 0; j--) {
					if (h[j] >= max) {
						max = h[j];
						ans++;
					}
				}
			} else {

				for (int j = i + 1; j < n; j++) {
					if (h[j] >= max) {
						max = h[j];
						ans++;
					}
				}

			}
			System.out.print(ans + " ");
		}
	}

	public void run() {
		try {
			InputStreamReader isr = new InputStreamReader(System.in);

			br = new BufferedReader(isr);
			out = new PrintWriter(System.out, true);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new ProblemD().run();
	}

}
