#include <iostream>
#include <vector>

typedef  unsigned __int32 Integer;

int main(void) {
	Integer n = 0, k = 0;
	std::cin >> n >> k;

	auto div_count = [=](Integer x) {
		Integer count = 0;
		for (Integer i = 1; i <= x; ++i) {
			if (x % i == 0) ++count;
		}
		return count;
	};
	auto table_symbol = [=](Integer x) { 
		return div_count(x) <= k ? '*' : '.'; 
	};

	for (size_t i = 0; i < n; ++i) {
		for (size_t j = 0; j < n; ++j) {
			std::cout << table_symbol(i*n + j + 1);
		}
		std::cout << std::endl;
	}
	return 0;
}