import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class D {

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextInt();
		}
		boolean[] l = new boolean[n];
		String s = nextToken();
		for (int i = 0; i < l.length; i++) {
			if (s.charAt(i) == 'L') {
				l[i] = true;
			}
		}
		int number = 0;
		TreeMap<Integer, Integer> set = new TreeMap<>();
		int[] ans = new int[n];
		for (int i = 0; i < l.length; i++) {
			if (l[i]) {
				ans[i] = number;
			}
			while (!set.isEmpty() && set.firstKey() < a[i]) {
				number -= set.get(set.firstKey());
				set.remove(set.firstKey());
			}
			number++;
			if (!set.containsKey(a[i])) {
				set.put(a[i], 1);
			} else {
				set.put(a[i], set.get(a[i]) + 1);
			}
		}
		set.clear();
		number = 0;
		for (int i = l.length - 1; i >= 0; i--) {
			if (!l[i]) {
				ans[i] = number;
			}
			while (!set.isEmpty() && set.firstKey() < a[i]) {
				number -= set.get(set.firstKey());
				set.remove(set.firstKey());
			}
			number++;
			if (!set.containsKey(a[i])) {
				set.put(a[i], 1);
			} else {
				set.put(a[i], set.get(a[i]) + 1);
			}
		}
		for (int i = 0; i < ans.length; i++) {
			out.print(ans[i] + " ");
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new D().run();
	}

}
