#include <bits/stdc++.h>
using namespace std;
#define ll long long

bool good(ll x)
{
    int prev = -1, dig;
    while(x > 0)
    {
        dig = x % 10;
        if (dig == prev)
            return false;
        x /= 10;
        prev = dig;
    }
    return true;
}

string IntToStr(ll x)
{
    string s = "";
    char c;
    while (x > 0)
    {
        c = ('0' + (x % 10));
        //cout << "c = " << c << endl;
        s += c;
        x /= 10;
    }

    reverse(s.begin(), s.end());
    return s;
}

ll StrToInt(string s)
{
    ll x = 0LL;
    for (char i : s)
    {
        x *= 10;
        x += (i - '0');
    }
    return x;
}

int find_(ll x)
{
    string s = IntToStr(x);
    for (int i = 0; i < s.length() - 1; ++i)
    {
        if (s[i] == s[i + 1])
            return i;
    }
    return -1;
}

ll ans(ll x)
{
    string s = IntToStr(x);
    int pos;
    while (!good(x))
    {
        pos = find_(x);
        if (s[pos] != '9')
        {
            s[pos + 1] += 1;
            for (int i = pos + 2; i < s.length(); ++i)
                s[i] = '0' + (i - (pos + 2)) % 2;
        }
        else
        {
            if (pos == 0)
            {
                s = "1" + s;
                for (int i = 1; i < s.size(); ++i)
                    s[i] = '0' + ((i - 1) % 2);
            }
            else
            {
                //cout << s << endl;
                s[pos - 1] += 1;
                //cout << s << endl;
                for (int i = pos; i < s.length(); ++i)
                    s[i] = '0' + (i - (pos)) % 2;
            }
        }
        x = StrToInt(s);
    }
    return x;
}

int main()
{
    //freopen("file.in", "r", stdin);
    ll n;
    cin >> n;
    ll a;
    if (!good(n))
        a = ans(n);
    else
    {
        if (good(n + 1))
            a = n + 1;
        else
            a = ans(n + 1);
    }
    cout << a << endl;
    return 0;
}
